#!/usr/bin/env python
# -*- coding: utf-8 -*-
from PIL import Image
import argparse
from xytool.common.interaction import Interaction

# #命令行输入参数处理
# parser = argparse.ArgumentParser()

# parser.add_argument('file')     #输入文件
# parser.add_argument('-o', '--output')   #输出文件
# parser.add_argument('--width', type = int, default = 80) #输出字符画宽
# parser.add_argument('--height', type = int, default = 80) #输出字符画高

#获取参数
# args = parser.parse_args()

# IMG = args.file
WIDTH = 80
HEIGHT = 80
OUTPUT = 'result.txt'
LANGUAGE = 'objc'   #objc  py  h5  java php  js  c/c++/c#

ascii_char = list("$@B%8&WM#*oahkbdpqwmZO0QLCJUYXzcvunxrjft/\|()1{}[]?-_+~<>i!lI;:,\"^`'. ")

# 将256灰度映射到70个字符上
def get_char(r,g,b,alpha = 256):
    if alpha == 0:
        return ' '
    length = len(ascii_char)
    gray = int(0.2126 * r + 0.7152 * g + 0.0722 * b)

    unit = (256.0 + 1)/length
    return ascii_char[int(gray/unit)]


if __name__ == '__main__':
    file_path = Interaction().select_file()

    # im = Image.open(file_path)
    rgb_im = Image.open(file_path)#打开图片
    im = rgb_im.convert('RGB')
    im = im.resize((WIDTH,HEIGHT), Image.NEAREST)

    txt = ""

    for i in range(HEIGHT):
        txt += '//'
        for j in range(WIDTH):
            # print(j)
            txt += get_char(*im.getpixel((j,i)))
        txt += '\n'

    print(txt)

    #字符画输出到文件
    if OUTPUT:
        with open(OUTPUT,'w') as f:
            f.write(txt)
    else:
        with open("output.txt",'w') as f:
            f.write(txt)


    